#include <windows.h>
#include <streams.h>

#include "AacDecFilter.h"


// 5.1ch_E~bNXݒ
#define DMR_CENTER			0.5		// 50%
#define DMR_FRONT			1.0		// 100%
#define DMR_REAR			0.7		// 70%
#define DMR_LFE				0.7		// 70%

/* ckkOɌJȂKvȂH
// sfBA^Cv̒`
static const AMOVIESETUP_MEDIATYPE AacDecPinType[] =
{
	{
		&MEDIATYPE_Audio,			// Major type
		&MEDIASUBTYPE_NULL			// Minor type
	},

	{
		&MEDIATYPE_Audio,			// Major type
		&MEDIASUBTYPE_PCM			// Minor type
	}
};

// s̒`
static const AMOVIESETUP_PIN AacDecPinsInfo[] =
{
	{
		L"Input",					// s̖O(p~)
		FALSE,						// _OΏۂǂ(o̓s͏FALSE)
		FALSE,						// o̓sǂ
		FALSE,						// s̃CX^XȂ\̗L
		FALSE,						// s̃CX^X𕡐쐬\
		0,							// sڑtB^CLSID(p~)
		0,							// sڑs̖O(p~)
		1UL,						// sT|[g郁fBATv
		&AacDecPinType[0]			// s
	},

	{
		L"Output",					// s̖O(p~)
		FALSE,						// _OΏۂǂ(o̓s͏FALSE)
		TRUE,						// o̓sǂ
		FALSE,						// s̃CX^XȂ\̗L
		FALSE,						// s̃CX^X𕡐쐬\
		0,							// sڑtB^CLSID(p~)
		0,							// sڑs̖O(p~)
		1UL,						// sT|[g郁fBATv
		&AacDecPinType[1]			// s
	}
};

// tB^̒`
const AMOVIESETUP_FILTER g_AacDecFilterInfo=
{
	&CLSID_AACDECFILTER,									// tB^CLSID
	AACDECFILTER_NAME,										// tB^
	MERIT_DO_NOT_USE,										// bgl
	sizeof(AacDecPinsInfo) / sizeof(AacDecPinsInfo[0]),		// s̐
	AacDecPinsInfo											// s̏
};
*/

CAacDecFilter::CAacDecFilter(LPUNKNOWN pUnk, HRESULT *phr)
	: CTransformFilter(NAME("AAC Decoder Filter"), pUnk, CLSID_AACDECFILTER)
	, m_AdtsParser(&m_AacDecoder)
	, m_AacDecoder(this)
	, m_pOutSample(NULL)
	, m_byCurChannelNum(0)
{

}

CAacDecFilter::~CAacDecFilter(void)
{

}

CUnknown * WINAPI CAacDecFilter::CreateInstance(LPUNKNOWN pUnk, HRESULT *phr)
{
	// CX^X쐬
	CAacDecFilter *pNewFilter = new CAacDecFilter(pUnk, phr);
	if(!pNewFilter)*phr = E_OUTOFMEMORY;
	
	return dynamic_cast<CUnknown *>(pNewFilter);
}

HRESULT CAacDecFilter::CheckInputType(const CMediaType* mtIn)
{
    CheckPointer(mtIn, E_POINTER);

	// łOK

	return S_OK;
}

HRESULT CAacDecFilter::CheckTransform(const CMediaType* mtIn, const CMediaType* mtOut)
{
    CheckPointer(mtIn, E_POINTER);
    CheckPointer(mtOut, E_POINTER);
    
	if(*mtOut->Type() == MEDIATYPE_Audio){
		if(*mtOut->Subtype() == MEDIASUBTYPE_PCM){

			// GUID_NULLł̓fobOAT[ĝŃ_~[ݒ肵ĉ			
			CMediaType MediaType;
			MediaType.InitMediaType();
			MediaType.SetType(&MEDIATYPE_Stream);
			MediaType.SetSubtype(&MEDIASUBTYPE_None);
			
			m_pInput->SetMediaType(&MediaType);
			
			return S_OK;
			}
		}
    
	return VFW_E_TYPE_NOT_ACCEPTED;
}

HRESULT CAacDecFilter::DecideBufferSize(IMemAllocator * pAllocator, ALLOCATOR_PROPERTIES *pprop)
{
	CAutoLock AutoLock(m_pLock);
	CheckPointer(pAllocator, E_POINTER);
	CheckPointer(pprop, E_POINTER);

	// obt@1΂悢
	if(!pprop->cBuffers)pprop->cBuffers = 1L;

	// Ƃ肠1MBm
	if(pprop->cbBuffer < 0x100000L)pprop->cbBuffer = 0x100000L;

	// AP[^vpeBݒ肵Ȃ
	ALLOCATOR_PROPERTIES Actual;
	HRESULT hr = pAllocator->SetProperties(pprop, &Actual);
	if(FAILED(hr))return hr;

	// v󂯓ꂽ
	if(Actual.cbBuffer < pprop->cbBuffer)return E_FAIL;

	return S_OK;
}

HRESULT CAacDecFilter::GetMediaType(int iPosition, CMediaType *pMediaType)
{
	CAutoLock AutoLock(m_pLock);
	CheckPointer(pMediaType, E_POINTER);

	if(iPosition < 0)return E_INVALIDARG;
	if(iPosition > 0)return VFW_S_NO_MORE_ITEMS;

	// fBA^Cvݒ
	pMediaType->InitMediaType();
	pMediaType->SetType(&MEDIATYPE_Audio);
	pMediaType->SetSubtype(&MEDIASUBTYPE_PCM);
	pMediaType->SetTemporalCompression(FALSE);
	pMediaType->SetSampleSize(0);
	pMediaType->SetFormatType(&FORMAT_WaveFormatEx);
		
	 // tH[}bg\̊m
	WAVEFORMATEX *pWaveInfo = reinterpret_cast<WAVEFORMATEX *>(pMediaType->AllocFormatBuffer(sizeof(WAVEFORMATEX)));
	if(!pWaveInfo)return E_OUTOFMEMORY;
	::ZeroMemory(pWaveInfo, sizeof(WAVEFORMATEX));

	// WAVEFORMATEX\̐ݒ(48KHz 16bit XeIŒ)
	pWaveInfo->wFormatTag = WAVE_FORMAT_PCM;
	pWaveInfo->nChannels = 2U;
	pWaveInfo->nSamplesPerSec = 48000UL;
	pWaveInfo->wBitsPerSample = 16U;
	pWaveInfo->nBlockAlign = pWaveInfo->wBitsPerSample * pWaveInfo->nChannels / 8U;
	pWaveInfo->nAvgBytesPerSec = pWaveInfo->nSamplesPerSec * pWaveInfo->nBlockAlign;

	return S_OK;
}

HRESULT CAacDecFilter::StartStreaming(void)
{
	// ADTSp[T
	m_AdtsParser.Reset();

	// AACfR[_I[v
	if(!m_AacDecoder.OpenDecoder())return E_FAIL;

	return S_OK;
}

HRESULT CAacDecFilter::StopStreaming(void)
{
	// AACfR[_N[Y
	m_AacDecoder.CloseDecoder();

	return S_OK;
}

const BYTE CAacDecFilter::GetCurrentChannelNum()
{
	return m_byCurChannelNum;
}

HRESULT CAacDecFilter::Transform(IMediaSample *pIn, IMediaSample *pOut)
{
	// ̓f[^|C^擾
	BYTE *pInData = NULL;
	pIn->GetPointer(&pInData);

	// o̓fBATvݒ
	m_pOutSample = pOut;
	pOut->SetActualDataLength(0UL);

	// ADTSp[Tɓ
	m_AdtsParser.StoreEs(pInData, pIn->GetActualDataLength());

	if(!pOut->GetActualDataLength())return S_FALSE;

	// ^CX^vݒ
	REFERENCE_TIME StartTime = 0LL;
	REFERENCE_TIME EndTime = 0LL;

	// ^CX^vݒ
	if(pIn->GetTime(&StartTime, &EndTime) == S_OK){
		pOut->SetTime(&StartTime, &EndTime);
		}

	// Xg[^Cݒ
	if(pIn->GetMediaTime(&StartTime, &EndTime) == S_OK){
		pOut->SetMediaTime(&StartTime, &EndTime);
		}

	return S_OK;
}

void CAacDecFilter::OnPcmFrame(const CAacDecoder *pAacDecoder, const BYTE *pData, const DWORD dwSamples, const BYTE byChannel)
{
	// o̓|C^擾
	const DWORD dwOffset = m_pOutSample->GetActualDataLength();
	DWORD dwOutSize = 0UL;

	BYTE *pOutBuff = NULL;
	m_pOutSample->GetPointer(&pOutBuff);
	pOutBuff = &pOutBuff[dwOffset];
	m_byCurChannelNum = byChannel;

	// _E~bNX
	switch(byChannel){
		case 1U:	dwOutSize = DownMixMono((short *)pOutBuff, (const short *)pData, dwSamples);		break;
		case 2U:	dwOutSize = DownMixStreao((short *)pOutBuff, (const short *)pData, dwSamples);		break;
		case 6U:	dwOutSize = DownMixSurround((short *)pOutBuff, (const short *)pData, dwSamples);	break;
		}

	// fBATvLTCYݒ
    m_pOutSample->SetActualDataLength(dwOffset + dwOutSize);
}

const DWORD CAacDecFilter::DownMixMono(short *pDst, const short *pSrc, const DWORD dwSamples)
{
	// 1ch  2ch d
	for(register DWORD dwPos = 0UL ; dwPos < dwSamples ; dwPos++){
		pDst[dwPos * 2UL + 0UL] = pSrc[dwPos];	// L
		pDst[dwPos * 2UL + 1UL] = pSrc[dwPos];	// R
		}

	// obt@TCYԂ
	return dwSamples * 4UL;
}

const DWORD CAacDecFilter::DownMixStreao(short *pDst, const short *pSrc, const DWORD dwSamples)
{
	// 2ch  2ch X[
	::CopyMemory(pDst, pSrc, dwSamples * 4UL);

	// obt@TCYԂ
	return dwSamples * 4UL;
}

const DWORD CAacDecFilter::DownMixSurround(short *pDst, const short *pSrc, const DWORD dwSamples)
{
	// 5.1ch  2ch _E~bNX

	int iOutLch, iOutRch;

	for(register DWORD dwPos = 0UL ; dwPos < dwSamples ; dwPos++){
		// _E~bNX
		iOutLch = (int)(
					(double)pSrc[dwPos * 6UL + 1UL]	* DMR_FRONT		+
					(double)pSrc[dwPos * 6UL + 3UL]	* DMR_REAR		+
					(double)pSrc[dwPos * 6UL + 0UL]	* DMR_CENTER	+
					(double)pSrc[dwPos * 6UL + 5UL]	* DMR_LFE
					);

		iOutRch = (int)(
					(double)pSrc[dwPos * 6UL + 2UL]	* DMR_FRONT		+
					(double)pSrc[dwPos * 6UL + 4UL]	* DMR_REAR		+
					(double)pSrc[dwPos * 6UL + 0UL]	* DMR_CENTER	+
					(double)pSrc[dwPos * 6UL + 5UL]	* DMR_LFE
					);

		// Nbv
		if(iOutLch > 32767L)iOutLch = 32767L;
		else if(iOutLch < -32768L)iOutLch = -32768L;

		if(iOutRch > 32767L)iOutRch = 32767L;
		else if(iOutRch < -32768L)iOutRch = -32768L;

		pDst[dwPos * 2UL + 0UL] = (short)iOutLch;	// L
		pDst[dwPos * 2UL + 1UL] = (short)iOutRch;	// R
		}

	// obt@TCYԂ
	return dwSamples * 4UL;
}
