#include <windows.h>
#include "EnumFilter.h"

CDirectShowUtil::CDirectShowUtil(void)
#if 0
	: m_FilterClassID()
#endif
{
	//CoInitialize(NULL);
	m_pFilterClassID = NULL;
	m_nFilterCount = 0;
}

CDirectShowUtil::~CDirectShowUtil(void)
{
	//CoUninitialize();
	Clear();
}

void CDirectShowUtil::Clear()
{
#if 0
	m_FilterClassID.RemoveAll();
#else
	if(m_pFilterClassID != NULL){
		int i;
		DIRECTSHOW_FILTER_INFO *pTmp;
		for(i=0;i<m_nFilterCount;++i){
			pTmp = (DIRECTSHOW_FILTER_INFO *)m_pFilterClassID->m_pNextData;
			if(m_pFilterClassID != NULL){
				delete m_pFilterClassID;
				m_pFilterClassID = pTmp;
			}
		}
		m_pFilterClassID = NULL;
		m_nFilterCount = 0;
	}
#endif
}

int CDirectShowUtil::GetFilterCount()
{
#if 0
	return m_FilterClassID.GetCount();
#else
	return m_nFilterCount;
#endif
}

#if 0
bool CDirectShowUtil::GetFilterInfo(const int iIndex,CLSID *pidClass,CStringW *pFriendryName)
{
	if(iIndex<0||iIndex>=GetFilterCount()) return false;
	DIRECTSHOW_FILTER_INFO &item = m_FilterClassID.GetAt(iIndex);
	if(pidClass) *pidClass = item.class_id;
	if(pFriendryName) *pFriendryName = item.friendry_name;
	return true;
}
#else
bool CDirectShowUtil::GetFilterInfo(const int iIndex,CLSID *pidClass,char *pszFriendryName,int cbFriendryName)
{
	if(iIndex < 0 || iIndex >= m_nFilterCount) return false;
	
	DIRECTSHOW_FILTER_INFO *pItem = GetFilterClassID(iIndex);


	if(pidClass != NULL){
		CopyMemory(pidClass,&pItem->class_id,sizeof(CLSID));
	}
	
	if(pszFriendryName != NULL){
		strcpy_s(pszFriendryName,cbFriendryName,pItem->m_szFriendryName);
	}
	return true;
}

DIRECTSHOW_FILTER_INFO *CDirectShowUtil::GetFilterClassID(int nIdx){
	int i;
	DIRECTSHOW_FILTER_INFO *pTmp;
	if(nIdx < 0 || nIdx >= m_nFilterCount) return NULL;

	pTmp = m_pFilterClassID;
	for(i = 0;i < m_nFilterCount;++i){
		if(i == nIdx)break;
		pTmp = (DIRECTSHOW_FILTER_INFO *)pTmp->m_pNextData;
	}

	return pTmp;
}
#endif

bool CDirectShowUtil::FindFilter(const CLSID *pidInType,const CLSID *pidInSubType,const CLSID *pidOutType,const CLSID *pidOutSubType)
{
	// idType idSubType ̃tB^(ϊtB^)
	bool bRet = false;
	IFilterMapper2 *pMapper=NULL;
	HRESULT hr=CoCreateInstance(CLSID_FilterMapper2,NULL, CLSCTX_INPROC, IID_IFilterMapper2,(void **) &pMapper);	
	if(SUCCEEDED(hr)) {
		IEnumMoniker *pEnum=NULL;
		GUID arInType[2],arOutType[2];
		GUID *pInTypes,*pOutTypes;
		if(pidInType)    arInType[0] = *pidInType;
		if(pidInSubType) arInType[1] = *pidInSubType;
		pInTypes = (pidInType && pidInSubType) ? arInType : NULL;
		if(pidOutType)   arOutType[0] = *pidOutType;
		if(pidOutSubType)arOutType[1] = *pidOutSubType;
		pOutTypes = (pidOutType && pidOutSubType) ? arOutType : NULL;

		hr = pMapper->EnumMatchingFilters(
			&pEnum,
			0,					// \ς
			TRUE,				// Svgp邩
			MERIT_DO_NOT_USE+1,	// ŏ̃bg
			TRUE,				// 1 ȏ̓̓s?
			pInTypes?1:0,		// ͂̃W[^Cv/Tu^Cv̑΂̐
			pInTypes,			// ͂̃W[^Cv/Tu^Cv̑΂̔z
			NULL,				// ̓fBA
			NULL,				// ̓s̃JeS
			FALSE,				// _łȂ΂ȂȂ
			TRUE,				// 1 ȏ̏o̓s
			pOutTypes?1:0,		// o͂̃W[^Cv/Tu^Cv̑΂̐
			pOutTypes,			// o͂̃W[^Cv/Tu^Cv̑΂̔z
			NULL,				// o̓fBA
			NULL);				// o̓s̃JeS
		if(SUCCEEDED(hr)){
			IMoniker *pMoniker;
			ULONG cFetched;
			while(pEnum->Next(1, &pMoniker, &cFetched) == S_OK){
				IPropertyBag *pPropBag;
				hr=pMoniker->BindToStorage(0, 0, IID_IPropertyBag, (void **)&pPropBag);
				if(SUCCEEDED(hr)){
					VARIANT varName,varID;
					VariantInit(&varName);
					VariantInit(&varID);
					hr=pPropBag->Read(L"FriendlyName", &varName, 0);
					if(SUCCEEDED(hr)){
						hr=pPropBag->Read(L"CLSID", &varID, 0);
						if(SUCCEEDED(hr)){
							bRet = true;
							DIRECTSHOW_FILTER_INFO stInfo;
#if 0							
							stInfo.friendry_name = varName.bstrVal;
#else
							ZeroMemory(&stInfo,sizeof(DIRECTSHOW_FILTER_INFO));
							WideCharToMultiByte(CP_ACP, 0, varName.bstrVal, -1, stInfo.m_szFriendryName, 119, NULL, NULL);
#endif
							
							CLSIDFromString(varID.bstrVal,&stInfo.class_id);
#if 0
							m_FilterClassID.Add(stInfo);
#else
							DIRECTSHOW_FILTER_INFO *pTmp;
							DIRECTSHOW_FILTER_INFO *pLastInfo;
							
							pTmp = new DIRECTSHOW_FILTER_INFO;
							ZeroMemory(pTmp,sizeof(DIRECTSHOW_FILTER_INFO));
							CopyMemory(pTmp,&stInfo,sizeof(DIRECTSHOW_FILTER_INFO));
							
							pLastInfo = GetFilterClassID(m_nFilterCount-1);
							if(pLastInfo == NULL){
								m_pFilterClassID = pTmp;
							}
							else{
								pLastInfo->m_pNextData = (void *)pTmp;
							}
							++m_nFilterCount;
#endif
							SysFreeString(varID.bstrVal);
							}
							SysFreeString(varName.bstrVal);
						}
						pPropBag->Release();
					}
				}
				pEnum->Release();
			}
			pMapper->Release();
		}
	return bRet;
}

// tB^w胁fBÃs
IPin* CDirectShowUtil::GetFilterPin(IBaseFilter *pFilter,const PIN_DIRECTION dir,const AM_MEDIA_TYPE *pMediaType)
{
	IEnumPins *pEnumPins=NULL;
	IPin *pPin;
	IPin *pRetPin=NULL;
	int dbgRef;

	if(pFilter->EnumPins(&pEnumPins)==S_OK ){
		ULONG cFetched;
		while(!pRetPin&&pEnumPins->Next(1,&pPin,&cFetched)==S_OK){
#if 0
			PIN_INFO stPin;
			if(pPin->QueryPinInfo(&stPin)==S_OK){

				if(stPin.pFilter != NULL){
					stPin.pFilter->Release();
					stPin.pFilter = NULL;
				}

				if(stPin.dir==dir){
					if(!pMediaType){
						// ĂOK
						pRetPin=pPin;
						//dbgRef=pRetPin->AddRef();
						break;
					} else {
						// DirectShowɂ܂ăs
						if(pPin->QueryAccept(pMediaType)==S_OK){
							pRetPin=pPin;
							//dbgRef=pRetPin->AddRef();
							break;
						}	
					}
				}
			}
#else
			PIN_DIRECTION PinDirThis;
			pPin->QueryDirection(&PinDirThis);
			if (dir == PinDirThis){
				pRetPin=pPin;
				break;
			}
			else{
				// DirectShowɂ܂ăs
				if(pPin->QueryAccept(pMediaType)==S_OK){
					pRetPin=pPin;
					break;
				}
			}
#endif
			dbgRef=pPin->Release();
		}
		dbgRef=pEnumPins->Release();
	}
	return pRetPin;
}