// DtvEngine.cpp: CDtvEngine NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#pragma warning(disable : 4995)

#include <windows.h>
#include <streams.h>
#include "DtvEngine.h"
#include "..\Util\StrUtil.h"

//////////////////////////////////////////////////////////////////////
// CDtvEngine \z/
//////////////////////////////////////////////////////////////////////

CDtvEngine::CDtvEngine(void)
	: m_pDtvEngineHandler(NULL)
	, m_wCurTransportStream(0U)
	, m_wCurService(0U)
	, m_wCurVideoPID(0U)
	, m_wCurAudioPID(0U)
	, m_bIsFileMode(FALSE)
{
	m_pBonSrcDecoder	= new CBonSrcDecoder(this);;		// TS\[X`[i[
	m_pTsPacketParser	= new CTsPacketParser(this);		// TSpPb^CU[
	m_pTsDescrambler	= new CTsDescrambler(this);			// TSfXNu[
	m_pProgManager		= new CProgManager(this);			// TSvO}l[W[
	m_pMediaViewer		= new CMediaViewer(this);			// fBAr[A[
	m_pMediaTee			= new CMediaTee(this);				// fBAeB[
	m_pFileWriter		= new CFileWriter(this);			// t@CC^[
	m_pFileReader		= new CFileReader(this);			// t@C[_[

	m_bIsInit = FALSE;
	m_bIsEnablePreview = FALSE;
	m_bStartEngine = FALSE;
	m_bIsCapture = FALSE;

}

CDtvEngine::~CDtvEngine(void)
{
	CloseEngine();

	delete m_pBonSrcDecoder;
	delete m_pTsPacketParser;
	delete m_pTsDescrambler;
	delete m_pProgManager;
	delete m_pMediaViewer;
	delete m_pMediaTee;
	delete m_pFileWriter;
	delete m_pFileReader;
}

BOOL CDtvEngine::OpenEngine(CDtvEngineHandler *pDtvEngineHandler, HWND hHostHwnd,HWND hMessageDrainHwnd,HMODULE hBonDrvDll,BOOL bDescramble,int *pnErrCode)
{
	int nErrorNo = DTV_ERRCODE_NOERROR;

	// SɎb
	CloseEngine();

	// Ot\}
	//
	// m_BonSrcDecoder or m_FileReader
	//		
	// m_TsPacketParser
	//		
	// m_TsDescrambler
	//		
	// m_MediaTee
	//						
	// m_ProgManager	m_FileWriter
	//		
	// m_MediaViewer

	// fR[_Ot\z
	m_pBonSrcDecoder->SetOutputDecoder(m_pTsPacketParser);	// Output #0 : CMediaData	
	if(bDescramble){
		// fXNuʂ
		m_pTsPacketParser->SetOutputDecoder(m_pTsDescrambler);// Output #0 : CTsPacket
		m_pTsDescrambler->SetOutputDecoder(m_pMediaTee);		// Output #0 : CTsPacket
	} else {
		// fXNuʂȂ
		m_pTsPacketParser->SetOutputDecoder(m_pMediaTee);		// Output #0 : CTsPacket
	}
	m_pMediaTee->SetOutputDecoder(m_pProgManager, 0UL);		// Output #0 : CTsPacket
	m_pMediaTee->SetOutputDecoder(m_pFileWriter, 1UL);		// Output #1 : CTsPacket
	m_pProgManager->SetOutputDecoder(m_pMediaViewer);			// Output #0 : CTsPacket

	// UZbg
	ResetEngine();

	// Cxgnhݒ
	m_pDtvEngineHandler = pDtvEngineHandler;

	// `[iJ
	if(!m_pBonSrcDecoder->OpenTuner(hBonDrvDll)){
		nErrorNo = DTV_ERRCODE_INITILIZE;
	}
	else{
		if(bDescramble){
			// B-CASJ[hJ
			if(!m_pTsDescrambler->OpenBcasCard())nErrorNo = DTV_ERRCODE_BCAS;
		}
		
		// r[AJ
		if(!m_pMediaViewer->OpenViewer(hHostHwnd,hMessageDrainHwnd))nErrorNo = DTV_ERRCODE_DIRECTSHOW;
	}
	
	//G[R[hێ
	if(pnErrCode != NULL){
		*pnErrCode = nErrorNo;
	}

	//G[
	if(nErrorNo != DTV_ERRCODE_NOERROR){
		CloseEngine();
		return FALSE;
	}
	
	//tOݒɂ
	m_bIsInit = TRUE;

	return TRUE;
}

BOOL CDtvEngine::CloseEngine(void)
{
	// fR[_N[Y
	m_pBonSrcDecoder->CloseTuner();
	m_pTsDescrambler->CloseBcasCard();
	m_pMediaViewer->CloseViewer();

	// Cxgnh
	m_pDtvEngineHandler = NULL;

	//tOݒɂ
	m_bIsInit = FALSE;

	return TRUE;
}

BOOL CDtvEngine::ResetEngine(void)
{
	if(m_bIsInit == FALSE)return FALSE;

	// fR[_OtZbg
	m_wCurTransportStream = 0;
	m_wCurVideoPID = m_wCurAudioPID = 0;
	m_pBonSrcDecoder->Reset();	

	return TRUE;
}

#if 0
BOOL CDtvEngine::EnablePreview(BOOL bEnable)
{
	if(m_bIsInit == FALSE)return FALSE;

	if(bEnable){
		// vr[L
		if(!m_pBonSrcDecoder->Play())return FALSE;
		if(!m_pMediaViewer->Play())return FALSE;
	}
	else{
		// vr[
		if(!m_pMediaViewer->Stop())return FALSE;
		if(!m_pBonSrcDecoder->Stop())return FALSE;
	}

	//Ԃێ
	m_bIsEnablePreview = bEnable;

	return TRUE;
}
#endif

BOOL CDtvEngine::StartEngine(BOOL bPreview){
	if(m_bStartEngine == TRUE)return TRUE;

	ErrMsg("[Inf]StartEngine");

	ErrMsg("[Inf]StartEngine : m_pBonSrcDecoder->Play");

	if(!m_pBonSrcDecoder->Play())return FALSE;
	

	if(bPreview == TRUE){
		ErrMsg("[Inf]StartEngine : m_pMediaViewer->Play");
		if(!m_pMediaViewer->Play())return FALSE;
	}

	m_bIsEnablePreview = bPreview;
	m_bStartEngine = TRUE;

	ErrMsg("[Inf]StartEngine : Finish");

	return TRUE;
}

BOOL CDtvEngine::StopEngine(void){
	if(m_bStartEngine == FALSE)return TRUE;

	ErrMsg("[Inf]StopEngine");

	// vr[
	if(m_bIsEnablePreview == TRUE){
		ErrMsg("[Inf]StopEngine : StopPreview");
		if(!m_pMediaViewer->Stop())return FALSE;
	}
	
	ErrMsg("[Inf]StopEngine : Decord");
	if(!m_pBonSrcDecoder->Stop())return FALSE;

	ErrMsg("[Inf]StopEngine : Finish");

	m_bIsEnablePreview = FALSE;
	m_bStartEngine = FALSE;

	return TRUE;
}

BOOL CDtvEngine::SetViewSize(int x,int y)
{
	bool bRet;

	if(m_bIsInit == FALSE)return FALSE;

	// EBhETCYݒ肷
	bRet =  m_pMediaViewer->SetViewSize(x,y);

	if(bRet == false)return FALSE;

	return TRUE;
}

BOOL CDtvEngine::SwitchFullscreen()
{
	bool bRet;
	if(m_bIsInit == FALSE)return FALSE;

	// EBhE[hƃtXN[[h؂ւ
	bRet = m_pMediaViewer->SwitchFullscreen();

	if(bRet == false)return FALSE;

	return TRUE;
}

BOOL CDtvEngine::SetVolume(long lVolume)
{
	bool bRet;
	if(m_bIsInit == FALSE)return FALSE;

	// I[fBI{[ݒ肷( -100.0() < fVolume < 0(ő) )
	bRet =  m_pMediaViewer->SetVolume(lVolume);

	if(bRet == false)return FALSE;

	return TRUE;
}

BOOL CDtvEngine::GetVideoSize(WORD *pwWidth,WORD *pwHeight)
{
	bool bRet;
	if(m_bIsInit == FALSE)return FALSE;

	bRet = m_pMediaViewer->GetVideoSize(pwWidth,pwHeight);

	if(bRet == false)return FALSE;

	return TRUE;
}

BOOL CDtvEngine::GetVideoAspectRatio(BYTE *pbyAspectRateX,BYTE *pbyAspectRateY)
{
	bool bRet;
	if(m_bIsInit == FALSE)return FALSE;

	bRet = m_pMediaViewer->GetVideoAspectRatio(pbyAspectRateX,pbyAspectRateY);

	if(bRet == false)return FALSE;

	return TRUE;
}

BYTE CDtvEngine::GetAudioCahnnelNum()
{
	if(m_bIsInit == FALSE)return FALSE;

	return m_pMediaViewer->GetAudioChannelNum();
}

BOOL CDtvEngine::SetStereoMode(int iMode)
{
	bool bRet;
	if(m_bIsInit == FALSE)return FALSE;

	bRet = m_pMediaViewer->SetStereoMode(iMode);

	if(bRet == false)return FALSE;

	return TRUE;
}

BOOL CDtvEngine::GetVideoDecorderName(LPWSTR lpName,int iBufLen)
{
	bool bRet;
	if(m_bIsInit == FALSE)return FALSE;

	bRet = m_pMediaViewer->GetVideoDecorderName(lpName, iBufLen);

	if(bRet == false)return FALSE;

	return TRUE;
}

BOOL CDtvEngine::DisplayVideoDecorderProperty(HWND hWndParent)
{
	bool bRet;
	if(m_bIsInit == FALSE)return FALSE;

	bRet = m_pMediaViewer->DisplayVideoDecorderProperty(hWndParent);

	if(bRet == false)return FALSE;

	return TRUE;
}

BOOL CDtvEngine::SetChannel(BYTE byTuningSpace, WORD wChannel)
{
	bool bRet;
	if(m_bIsInit == FALSE)return FALSE;

	// `lύX
	bRet = m_pBonSrcDecoder->SetChannel((DWORD)byTuningSpace, (DWORD)wChannel);

	if(bRet) ResetEngine();

	if(bRet == false)return FALSE;

	return TRUE;
}

BOOL CDtvEngine::SetService(WORD wService)
{
	if(m_bIsInit == FALSE)return FALSE;

	// T[rXύX(wService==0xFFFFȂPAT擪T[rX)

	if(wService < m_pProgManager->GetServiceNum() || wService==0xFFFF){		
		WORD wServiceID = 0xFFFF;
		WORD wVideoPID = 0xFFFF;
		WORD wAudioPID = 0xFFFF;

		// 擪PMT܂Ŏsɂ
		if(!m_pProgManager->GetServiceID(&wServiceID,wService)) return FALSE;
		if(wService==0xFFFF){
			m_wCurService = 0;
			m_wCurVideoPID = m_wCurAudioPID = 0;
		} else {
			m_wCurService = wService;
		}
		
		m_pProgManager->GetServiceEsPID(&wVideoPID, &wAudioPID, m_wCurService);

		//TRACE(TEXT("------- Service Select -------\n"));
		//TRACE(TEXT("ServiceID = %04X(%d)\n"),m_wCurService,wServiceID);

		if(m_wCurVideoPID != wVideoPID){
			m_pMediaViewer->SetVideoPID(wVideoPID);
			m_wCurVideoPID = wVideoPID;
			//TRACE(TEXT("Change Video PID = %04X\n"),wVideoPID);
			}
		if(m_wCurAudioPID != wAudioPID){
			m_pMediaViewer->SetAudioPID(wAudioPID);
			m_wCurAudioPID = wAudioPID;
			//TRACE(TEXT("Change Audio PID = %04X\n"),wAudioPID);
		}			
		
		return TRUE;
	}

	return FALSE;
}

WORD CDtvEngine::GetService(void)
{
	if(m_bIsInit == FALSE)return FALSE;
	// T[rX擾
	return m_wCurService;
}

BOOL CDtvEngine::PlayFile(LPCTSTR lpszFileName,int *pnErrCode)
{
	if(m_bIsInit == FALSE)return FALSE;

	// OtŜ̔rȂƂ܂ƂɓȂII

	// Đ̏ꍇ͕
	m_pFileReader->StopReadAnsync();

	// XbhI҂
	while(m_pFileReader->IsAnsyncReadBusy()){
		::Sleep(1UL);
		}

	m_pFileReader->CloseFile();

	// foCXĐ̏ꍇ̓Otč\z
	if(!m_bIsFileMode){
		m_pBonSrcDecoder->Stop();
		m_pBonSrcDecoder->SetOutputDecoder(NULL);
		m_pFileReader->SetOutputDecoder(m_pTsPacketParser);
	}

	try{
		// OtZbg
		m_pFileReader->Reset();

		// t@CI[v
		if(!m_pFileReader->OpenFile(lpszFileName))throw DTV_ERRCODE_CANT_OPEN_FILE;
		
		// 񓯊ĐJn
		if(!m_pFileReader->StartReadAnsync())throw DTV_ERRCODE_CANT_START_ASYNCH;
	}
	
	catch(const int nErrorStep){
		// G[
		StopFile();

		if(pnErrCode != NULL){
			*pnErrCode = nErrorStep;
		}

		return FALSE;
	}

	m_bIsFileMode = TRUE;

	return TRUE;
}

BOOL CDtvEngine::StopFile(void)
{
	if(m_bIsInit == FALSE)return FALSE;
	if(m_bIsFileMode == FALSE)return TRUE;

	// OtŜ̔rȂƂ܂ƂɓȂII

	m_bIsFileMode = FALSE;

	// Đ̏ꍇ͕
	m_pFileReader->StopReadAnsync();
	
	// XbhI҂
	while(m_pFileReader->IsAnsyncReadBusy()){
		::Sleep(1UL);
	}

	m_pFileReader->CloseFile();
	
	// Otč\z
	m_pFileReader->SetOutputDecoder(NULL);
	m_pBonSrcDecoder->SetOutputDecoder(m_pTsPacketParser);
	m_pBonSrcDecoder->Play();

	return TRUE;
}

DWORD CDtvEngine::GetLastError(void)
{
	return 0UL;
}

//t@Co
BOOL CDtvEngine::StartCapture(char *pszFile){
	bool bRet;

	if(m_bIsInit == FALSE)return FALSE;
	if(pszFile == NULL)return FALSE;
	if(m_pFileWriter == NULL)return FALSE;

	bRet = m_pFileWriter->OpenFile(pszFile);

	if(bRet == false)return FALSE;

	m_bIsCapture = TRUE;

	return TRUE;
}

BOOL CDtvEngine::StopCapture(void){

	if(m_bIsInit == FALSE)return FALSE;
	if(m_pFileWriter == NULL)return FALSE;
	if(m_bIsCapture == FALSE)return TRUE;

	m_pFileWriter->CloseFile();

	m_bIsCapture = FALSE;

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
//GW̏Ԏ擾
BOOL CDtvEngine::IsEnablePreview(void){
	return m_bIsEnablePreview;
}

BOOL CDtvEngine::IsFileMode(void){
	return m_bIsFileMode;
}

BOOL CDtvEngine::IsInit(void){
	return m_bIsInit;
}

BOOL CDtvEngine::IsStartEngine(void){
	return m_bStartEngine;
}

BOOL CDtvEngine::IsCapture(void){
	return m_bIsCapture;
}

//////////////////////////////////////////////////////////////////////////////
//Cxgnh
DWORD CDtvEngine::SendDtvEngineEvent(DWORD dwEventID, PVOID pParam)
{
	// CxgnhɃCxg𑗐M
	if(m_pDtvEngineHandler){
		return m_pDtvEngineHandler->OnDtvEngineEvent(this, dwEventID, pParam);
	}

	return 0UL;
}

const DWORD CDtvEngine::OnDecoderEvent(CMediaDecoder *pDecoder, const DWORD dwEventID, PVOID pParam)
{
	// fR[_̃Cxg󂯎(b)
	if(pDecoder == m_pProgManager){
		
		// vO}l[W̃Cxg
		WORD wTransportStream = m_pProgManager->GetTransportStreamID();
		switch(dwEventID){
			case CProgManager::EID_SERVICE_LIST_UPDATED :
				// T[rX̍\ω				
				if(m_wCurTransportStream!=wTransportStream) {
					// Xg[IDςĂȂ珉
					//TRACE(TEXT("Stream Change!! %04X\n"),wTransportStream);
					// ̎_ł܂T[rXSĂȂƂ̂ŁAۗ
					if(SetService(0xFFFF)){
						m_wCurTransportStream = wTransportStream;
						SendDtvEngineEvent(DTV_EVENT_CHANGE_STREAM, static_cast<PVOID>(m_pProgManager));
					}
				} else {
					// Xg[ID͓A\ESPIDς\
					SetService(m_wCurService);
				}
				return 0UL;
				
			case CProgManager::EID_SERVICE_INFO_UPDATED :
				// T[rXXVꂽ
				SendDtvEngineEvent(DTV_EVENT_SERVICENAME_UPDATE, static_cast<PVOID>(m_pProgManager));
				
				return 0UL;
		}
	}
	else if(pDecoder == m_pFileReader){
		
		CFileReader *pFileReader = dynamic_cast<CFileReader *>(pDecoder);
		
		// t@C[_̃Cxg
		switch(dwEventID){
			case CFileReader::EID_READ_ASYNC_START :
				// 񓯊[hJn
				return 0UL;
			
			case CFileReader::EID_READ_ASYNC_END :
				// 񓯊[hI
				return 0UL;
			
			case CFileReader::EID_READ_ASYNC_POSTREAD :
				// 񓯊[h
				
				if(pFileReader->GetReadPos() >= pFileReader->GetFileSize()){
					// ŏɊ߂([vĐ)
					pFileReader->SetReadPos(0ULL);
					pFileReader->Reset();
					}
				
				return 0UL;
			}		
		}

	return 0UL;
}


//////////////////////////////////////////////////////////////////////
// CDtvEngineHandler \z/
//////////////////////////////////////////////////////////////////////

const DWORD CDtvEngineHandler::OnDtvEngineEvent(CDtvEngine *pEngine, const DWORD dwEventID, PVOID pParam)
{
	// ftHg̏
	return 0UL;
}
