#include <windows.h>
#include "CSplashWindow.h"
#include "..\resource.h"

//////////////////////////////////////////////////////////////////////////////
//NX̎
CSplashWindow::CSplashWindow(){
	
	m_hWnd = NULL;
	m_hWOwner = NULL;
	m_hInst = NULL;
	hFont = NULL;
	
	//C[֐N
	OSVERSIONINFO osver;
	ZeroMemory(&osver,sizeof(OSVERSIONINFO));
	osver.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
	GetVersionEx(&osver);
	if(osver.dwMajorVersion >= 5){
		//DLL[h
		hDll = LoadLibrary("user32.dll");
		if (hDll) {
			// APIAhX擾
			lpSetLayeredWindowAttributes=(lSetLayeredWindowAttributes *)GetProcAddress((HINSTANCE)hDll,"SetLayeredWindowAttributes");
		}
	}
	else{
		lpSetLayeredWindowAttributes = NULL;
		hDll = NULL;
	}

}


CSplashWindow::~CSplashWindow(){
	if(hDll != NULL)FreeLibrary((HINSTANCE)hDll);
	if(hFont != NULL)DeleteObject(hFont);
}

////////////////////////////////////////////////////////////////
//EChE쐬ANXo^
HWND CSplashWindow::CreateWnd(DWORD dwExStyle,DWORD dwStyle,
					int x,int y,int nWidth,int nHeight,
					HWND hwndParent,
					HMENU hmenu,
					HINSTANCE hinst){
					
	m_hInst = hinst;
	m_hWOwner = hwndParent;

	m_hWnd = CreateWindowEx(dwExStyle|WS_EX_LAYERED,CBASE_WINDOW_CLASS,NULL,dwStyle,
		x,y,nWidth,nHeight,hwndParent,hmenu,hinst,(VOID *)this);

	SetAlphaColor(RGB(0,0,0),255,LWA_COLORKEY|LWA_ALPHA);

	return m_hWnd;
}

//////////////////////////////////////////////////////////////////////////////
//C[EChE
BOOL CSplashWindow::SetAlphaColor(COLORREF col,BYTE bAlpha,DWORD dwFlags){
	//OSVERSIONINFO osver;
	//J[L[ݒ肷
	//colKey = col;
	
	if(m_hWnd == NULL)return FALSE;
	if(lpSetLayeredWindowAttributes == NULL)return FALSE;
	
	//Windows200ȑOOSł͔Ή
	//ZeroMemory(&osver,sizeof(OSVERSIONINFO));
	//osver.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
	//GetVersionEx(&osver);
	//if(osver.dwMajorVersion < 5)return FALSE;
	
	return lpSetLayeredWindowAttributes(m_hWnd,col,bAlpha,dwFlags);
}

/////////////////////////////////////////////////////////////////////
//`
BOOL CSplashWindow::DrawMessage(int x,int y,char *pszText){
	HDC hdc;//,hdc;
	HGDIOBJ hObj;
	char text[80];//̍ő啶80܂
	int draw_x,draw_y;//`ʒu
	SIZE StrSize;//`̈擾p
	int iStrLength;
	int i,j;
	RECT rc;

	if(m_hWnd == NULL)return FALSE;
	if(pszText == NULL) return FALSE;

	GetClientRect(m_hWnd,&rc);
		
	hdc = GetDC(m_hWnd);
		
	hObj = SelectObject(hdc,hFont);

	SetBkMode(hdc,TRANSPARENT);
	SetBkColor(hdc,RGB(0,0,0));
		
	iStrLength = strlen(pszText) + 1;
	draw_y = y+1;
	draw_x = x;
	for(i = 0;i<iStrLength;++i){
		//s܂ł̕Rs[
		j = 0;
		while(i < iStrLength && j < 80){
			text[j] = pszText[i];
			if(text[j] == '\n' || text[j] == '\0')break;
			++j;
			++i;
		}
		text[j] = '\0';

		//TCYvZ
		GetTextExtentPoint32(hdc,text,strlen(text),&StrSize);
	
		//`悷
		SetTextColor(hdc,RGB(255,255,255));
		TextOut(hdc,draw_x-1,draw_y,text,strlen(text));
		TextOut(hdc,draw_x+1,draw_y,text,strlen(text));
		TextOut(hdc,draw_x,draw_y-1,text,strlen(text));
		TextOut(hdc,draw_x,draw_y+1,text,strlen(text));
		SetTextColor(hdc,RGB(255,144,0));
		TextOut(hdc,draw_x,draw_y,text,strlen(text));
		draw_y = draw_y + StrSize.cy;
	}
	
	//foCXReLXg
	SelectObject(hdc,hObj);
	ReleaseDC(m_hWnd,hdc);

	return TRUE;
}

/////////////////////////////////////////////////////////////////////
//bZ[W֐
LRESULT CSplashWindow::OnWmCreate(HWND hW, UINT uMsg, WPARAM wParam, LPARAM lParam){
	//nhێ
	m_hWnd = hW;
	int iXPos,iYPos;

#ifdef IDB_BMP_SPLASH
	if(m_PictureSprite.CreateSpriteFromFile("logo.bmp",RGB(0,16,0)) == FALSE){
		m_PictureSprite.CreateSpriteFromResource(m_hInst,IDB_BMP_SPLASH,RGB(0,16,0));
	}
#else
	m_PictureSprite.CreateSpriteFromFile("logo.bmp",RGB(0,16,0));
#endif

	iXPos = (GetSystemMetrics(SM_CXSCREEN) - m_PictureSprite.GetWidth()) / 2;
	iYPos = (GetSystemMetrics(SM_CYSCREEN) - m_PictureSprite.GetHeight()) / 2;

	SetWindowPos(hW,NULL,iXPos,iYPos,m_PictureSprite.GetWidth(),m_PictureSprite.GetHeight(),SWP_NOZORDER);


	hFont = CreateFont(12, 0, 0, 0,
			FW_SEMIBOLD,
			FALSE, FALSE, FALSE, 
			SHIFTJIS_CHARSET , OUT_TT_PRECIS , 
			CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY, 
			DEFAULT_PITCH , "lr SVbN");

	return 0;
}

LRESULT CSplashWindow::OnWmPaint(HWND hW, UINT uMsg, WPARAM wParam, LPARAM lParam){

	PAINTSTRUCT ps;

	//`Jn
	HDC hdc = BeginPaint(hW,&ps);

	//////////////////////////////////////////////////////////////////////////
	//wi`悷
	m_PictureSprite.Draw(hdc,0,0);

	EndPaint(hW,&ps);
	
	return 0;
}


LRESULT CSplashWindow::OnWmClose(HWND hW,UINT msg,WPARAM wP,LPARAM lP){

	//XvCg
	m_PictureSprite.Release();
	
	//tHg폜
	if(hFont != NULL){
		DeleteObject(hFont);
		hFont = NULL;
	}

	//EChEj
	DestroyWindow(hW);

	return 0;
}

LRESULT CSplashWindow::WndProck(HWND hW, UINT uMsg, WPARAM wParam, LPARAM lParam){

	LRESULT lRet = 0;

	switch (uMsg){
	case WM_CREATE:
		OnWmCreate(hW, uMsg, wParam, lParam);
		break;
	case WM_PAINT:
		OnWmPaint(hW, uMsg, wParam, lParam);
		break;
	case WM_CLOSE:
		OnWmClose(hW, uMsg, wParam, lParam);
		break;
	default:
		lRet = DefWindowProc(hW,uMsg,wParam,lParam);
		break;
	}

	return lRet;
}
